#include<bits/stdc++.h>
using namespace std;
int main(){

    int n,q;
    cin>>n>>q;

    long long d1,p1;
    cin>>d1>>p1;

    long long niz1[150100];
    long long nizD1[150100];

    niz1[0] = 0;
    nizD1[0] = d1;

    for(int i=1; i<min(150000,n); i++){

        long long d, p;
        cin>>d>>p;
        nizD1[i] = d;

        niz1[i] = niz1[i-1] + min(d-d1,p1);
        //p += max(0,p1-d+d1);
        if(p1 > d-d1){
            p += p1-d+d1;
        }

        p1 = p;
        d1 = d;
    }
    long long pKrajnje = p1;

    long long niz2[150100];
    long long nizD2[150100];

    if(n>150000){

        long long d2,p2;
        cin>>d2>>p2;

        niz2[0] = niz1[149999] + min(d2-d1,p1);
        //p2 += max(0, p1-d2+d1);
        if(p1 > d2-d1){
            p2 += p1-d2+d1;
        }

        nizD2[0] = d2;

        for(int i=1;i<n-150000;i++){

            long long d,p;
            cin>>d>>p;
            nizD2[i] = d;

            niz2[i] = niz2[i-1] + min(d-d2,p2);
            //p += max(0,p2-d+d2);
            if(p2 > d-d2){
                p += p2-d+d2;
            }

            p2 = p;
            d2 = d;
        }
        pKrajnje = p2;
    }

    /*for(int i=0;i<8;i++){
        cout<<niz1[i]<<" "<<nizD1[i]<<endl;
    }
    cout<<endl;
    cout<<pKrajnje;*/

/////////////////////////////////////////

    if(q == 1){

        int j;
        cin>>j;

        int idx = -1;
        bool bul=true;

        for(int i=0;i<150000;i++){

            if(nizD1[i] > j){
                idx = i-1;
                break;
            }
        }
        if(idx == -1){
            bool bul = false;
            for(int i=0;i<n-150000;i++){

                if(nizD2[i] > j){
                    idx = i-1;
                    break;
                }
            }
        }
        if(idx == -1){

            if(n<=150000){
                cout<<niz1[n-1] + min(pKrajnje, j - nizD1[n-1]);
            }
            else{
                cout<<niz2[n-150001] + min(pKrajnje , j - nizD2[n-150001]);
            }
        }
        else{

            if(bul){

                long long ppp = niz1[idx+1] - niz1[idx];
                cout<<niz1[idx] + min(ppp, j - nizD1[idx]);
            }
            else{

                long long ppp = niz2[idx+1] - niz2[idx];
                cout<<niz2[idx] + min(ppp, j - nizD2[idx]);
            }

        }
    }

}